#include "HdecayWrap.h"
#include "Wrappers.h"

using namespace std;
map<string,double> HdecayA,HdecayHlight,HdecayHheavy,HdecayHcharged,HdecayTop,HdecayHsm,HdecayHS;


void HdecayCalc(void){
  double dummy;
  hdecaycallplain_(dummy);
}

void HdecayCalc2HDM(std::map<std::string,double> & HdecayA,std::map<std::string,double> & HdecayHlight,std::map<std::string,double> & HdecayHheavy,std::map<std::string,double> & HdecayHcharged,std::map<std::string,double> & HdecayTop){

  double ABRB_out,ABRL_out,ABRM_out,ABRS_out,ABRC_out,ABRT_out,ABRG_out,ABRGA_out, ABRZGA_out,ABRZ_out,AWDTH_out,HLBRB_out,HLBRL_out,HLBRM_out,HLBRS_out,HLBRC_out,HLBRT_out,HLBRG_out,HLBRGA_out,HLBRZGA_out,HLBRW_out,HLBRZ_out,HLBRA_out,HLBRAZ_out,HLBRHW_out,HLWDTH_out,HHBRB_out,HHBRL_out,HHBRM_out,HHBRS_out,HHBRC_out,HHBRT_out,HHBRG_out,HHBRGA_out,HHBRZGA_out,HHBRW_out,HHBRZ_out,HHBRH_out,HHBRA_out,HHBRAZ_out,HHBRHW_out,HHWDTH_out,HCBRB_out,HCBRL_out,HCBRM_out,HCBRBU_out,HCBRS_out,HCBRC_out,HCBRT_out,HCBRW_out,HCBRA_out,HCWDTH_out,hcbrcd_out,hcbrts_out,hcbrtd_out,hcbrwhh_out,hhbrchch_out,hlbrchch_out,abrhhaz_out,abrhawphm_out,gamt0_out,gamt1_out;

  hdecaycall2hdm_(ABRB_out,ABRL_out,ABRM_out,ABRS_out,ABRC_out,ABRT_out,ABRG_out,ABRGA_out, ABRZGA_out,ABRZ_out,AWDTH_out,HLBRB_out,HLBRL_out,HLBRM_out,HLBRS_out,HLBRC_out,HLBRT_out,HLBRG_out,HLBRGA_out,HLBRZGA_out,HLBRW_out,HLBRZ_out,HLBRA_out,HLBRAZ_out,HLBRHW_out,HLWDTH_out,HHBRB_out,HHBRL_out,HHBRM_out,HHBRS_out,HHBRC_out,HHBRT_out,HHBRG_out,HHBRGA_out,HHBRZGA_out,HHBRW_out,HHBRZ_out,HHBRH_out,HHBRA_out,HHBRAZ_out,HHBRHW_out,HHWDTH_out,HCBRB_out,HCBRL_out,HCBRM_out,HCBRBU_out,HCBRS_out,HCBRC_out,HCBRT_out,HCBRW_out,HCBRA_out,HCWDTH_out,hcbrcd_out,hcbrts_out,hcbrtd_out,hcbrwhh_out,hhbrchch_out,hlbrchch_out,abrhhaz_out,abrhawphm_out,gamt0_out,gamt1_out);

  HdecayA["BR(A -> b bbar)"]=ABRB_out;
  HdecayA["BR(A -> tau+ tau-)"]=ABRL_out;
  HdecayA["BR(A -> mu+ mu-)"]=ABRM_out;
  HdecayA["BR(A -> s sbar)"]=ABRS_out;
  HdecayA["BR(A -> c cbar)"]=ABRC_out;
  HdecayA["BR(A -> t tbar)"]=ABRT_out;
  HdecayA["BR(A -> g g)"]=ABRG_out;
  HdecayA["BR(A -> gamma gamma)"]=ABRGA_out;
  HdecayA["BR(A -> Z gamma)"]=ABRZGA_out;
  HdecayA["BR(A -> Z h)"]=ABRZ_out;
  HdecayA["BR(A -> H Z)"]=abrhhaz_out; ////HdecayA["BR(A -> A Z)"]=abrhhaz_out; /////// 
  HdecayA["BR(A -> W+ H-)"]=abrhawphm_out; ////HdecayA["BR(A -> A W+ H-)"]=abrhawphm_out; /////
  HdecayA["Width"]=AWDTH_out;

  HdecayHlight["BR(h -> b bbar)"]=HLBRB_out;
  HdecayHlight["BR(h -> tau+ tau-)"]=HLBRL_out;
  HdecayHlight["BR(h -> mu+ mu-)"]=HLBRM_out;
  HdecayHlight["BR(h -> s sbar)"]=HLBRS_out;
  HdecayHlight["BR(h -> c cbar)"]=HLBRC_out;
  HdecayHlight["BR(h -> t tbar)"]=HLBRT_out;
  HdecayHlight["BR(h -> g g)"]=HLBRG_out;
  HdecayHlight["BR(h -> gamma gamma)"]=HLBRGA_out;
  HdecayHlight["BR(h -> Z gamma)"]=HLBRZGA_out;
  HdecayHlight["BR(h -> W+ W-)"]=HLBRW_out;
  HdecayHlight["BR(h -> Z Z)"]=HLBRZ_out;
  HdecayHlight["BR(h -> A A)"]=HLBRA_out;
  HdecayHlight["BR(h -> Z A)"]=HLBRAZ_out;
  HdecayHlight["BR(h -> H+ H-)"]=hlbrchch_out; 
  HdecayHlight["BR(h -> W+ H-)+BR(h -> W- H+)"]=HLBRHW_out;

  HdecayHlight["Width"]=HLWDTH_out;

  HdecayHheavy["BR(H -> b bbar)"]=HHBRB_out;
  HdecayHheavy["BR(H -> tau+ tau-)"]=HHBRL_out;
  HdecayHheavy["BR(H -> mu+ mu-)"]=HHBRM_out;
  HdecayHheavy["BR(H -> s sbar)"]=HHBRS_out;
  HdecayHheavy["BR(H -> c cbar)"]=HHBRC_out;
  HdecayHheavy["BR(H -> t tbar)"]=HHBRT_out;
  HdecayHheavy["BR(H -> g g)"]=HHBRG_out;
  HdecayHheavy["BR(H -> gamma gamma)"]=HHBRGA_out;
  HdecayHheavy["BR(H -> Z gamma)"]=HHBRZGA_out;
  HdecayHheavy["BR(H -> W+ W-)"]=HHBRW_out;
  HdecayHheavy["BR(H -> Z Z)"]=HHBRZ_out;
  HdecayHheavy["BR(H -> h h)"]=HHBRH_out;
  HdecayHheavy["BR(H -> A A)"]=HHBRA_out;
  HdecayHheavy["BR(H -> Z A)"]=HHBRAZ_out;
  HdecayHheavy["BR(H -> W+ H-)+BR(H -> W- H+)"]=HHBRHW_out;
  HdecayHheavy["BR(H -> H+ H-)"]=hhbrchch_out; 

  HdecayHheavy["Width"]=HHWDTH_out;

  HdecayHcharged["BR(H+ -> c bbar)"]=HCBRB_out;
  HdecayHcharged["BR(H+ -> tau+ nu_tau)"]=HCBRL_out;
  HdecayHcharged["BR(H+ -> mu+ nu_mu)"]=HCBRM_out;
  HdecayHcharged["BR(H+ -> u bbar)"]=HCBRBU_out;
  HdecayHcharged["BR(H+ -> u sbar)"]=HCBRS_out;
  HdecayHcharged["BR(H+ -> c dbar)"]=hcbrcd_out; 
  HdecayHcharged["BR(H+ -> c sbar)"]=HCBRC_out;
  HdecayHcharged["BR(H+ -> t bbar)"]=HCBRT_out;
  HdecayHcharged["BR(H+ -> t sbar)"]=hcbrts_out; 
  HdecayHcharged["BR(H+ -> t dbar)"]=hcbrtd_out; 
  HdecayHcharged["BR(H+ -> W+ h)"]=HCBRW_out;
  HdecayHcharged["BR(H+ -> W+ H)"]=hcbrwhh_out; 
  HdecayHcharged["BR(H+ -> W+ A)"]=HCBRA_out;

  HdecayHcharged["Width"]=HCWDTH_out;

  HdecayTop["BR(t -> b W+)"]=gamt0_out/gamt1_out;  
  HdecayTop["BR(t -> b H+)"]=(gamt1_out-gamt0_out)/gamt1_out;  
  HdecayTop["Width"]=gamt1_out;

}

void HdecayCalcSM(std::map<std::string,double> & HdecayHsm){

  double SMBRB_out,SMBRL_out,SMBRM_out,SMBRS_out,SMBRC_out,SMBRT_out,SMBRG_out,SMBRGA_out,SMBRZGA_out,SMBRW_out,SMBRZ_out,SMWDTH_out;

  hdecaycallsm_(SMBRB_out,SMBRL_out,SMBRM_out,SMBRS_out,SMBRC_out,SMBRT_out,SMBRG_out,SMBRGA_out,SMBRZGA_out,SMBRW_out,SMBRZ_out,SMWDTH_out);

  HdecayHsm["BR(Hsm -> b bbar)"]=SMBRB_out;
  HdecayHsm["BR(Hsm -> tau+ tau-)"]=SMBRL_out;
  HdecayHsm["BR(Hsm -> mu+ mu-)"]=SMBRM_out;
  HdecayHsm["BR(Hsm -> s sbar)"]=SMBRS_out;
  HdecayHsm["BR(Hsm -> c cbar)"]=SMBRC_out;
  HdecayHsm["BR(Hsm -> t tbar)"]=SMBRT_out;
  HdecayHsm["BR(Hsm -> g g)"]=SMBRG_out;
  HdecayHsm["BR(Hsm -> gamma gamma)"]=SMBRGA_out;
  HdecayHsm["BR(Hsm -> Z gamma)"]=SMBRZGA_out;
  HdecayHsm["BR(Hsm -> W+ W-)"]=SMBRW_out;
  HdecayHsm["BR(Hsm -> Z Z)"]=SMBRZ_out;
  HdecayHsm["Width"]=SMWDTH_out;

}

void CreateInputFileHdecay2HDM(int Type, double tanbeta,double alpha, double mHlight,double mHheavy, double mA, double mCharged,double m12sq){
  ofstream outfile ; // ofstream output file object to write file;
#ifdef SHDECAYMODE
  outfile.open("shdecay.in"); 
#else
  outfile.open("hdecay.in");
#endif


  outfile<<"SLHAIN   = 0"<<endl;
  outfile<<"SLHAOUT  = 0"<<endl;
  outfile<<"COUPVAR  = 0"<<endl;
  outfile<<"HIGGS    = 5"<<endl;
  outfile<<"OMIT ELW = 0"<<endl;
  outfile<<"SM4      = 0"<<endl;
  outfile<<"FERMPHOB = 0"<<endl;
  outfile<<"2HDM     = 1"<<endl;
  outfile<<"MODEL    = 1"<<endl;
  outfile<<fixed<<setprecision(8);
  int exponent=log10(abs(tanbeta));
  outfile<<"TGBET    = "<<tanbeta/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"MABEG    = 125.D0"<<endl;
  outfile<<"MAEND    = 1000.D0"<<endl;
  outfile<<"NMA      = 1"<<endl;
  outfile<<"********************* hMSSM (MODEL = 10) *********************************"<<endl;
  outfile<<"MHL      = 125.D0"<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"ALS(MZ)  = 0.118D0"<<endl;
  outfile<<"MSBAR(2) = 0.095D0"<<endl;
  outfile<<"MCBAR(3) = 0.986D0"<<endl;
  outfile<<"MBBAR(MB)= 4.180D0"<<endl;
  outfile<<"MT       = 172.5D0"<<endl;
  outfile<<"MTAU     = 1.77682D0"<<endl;
  outfile<<"MMUON    = 0.1056583715D0"<<endl;
  outfile<<"1/ALPHA  = 137.0359997D0"<<endl;
  outfile<<"GF       = 1.1663787D-5"<<endl;
  outfile<<"GAMW     = 2.08430D0"<<endl;
  outfile<<"GAMZ     = 2.49427D0"<<endl;
  outfile<<"MZ       = 91.15348D0"<<endl;
  outfile<<"MW       = 80.35797D0"<<endl;
  outfile<<"VTB      = 0.9991D0"<<endl;
  outfile<<"VTS      = 0.0404D0"<<endl;
  outfile<<"VTD      = 0.00867D0"<<endl;
  outfile<<"VCB      = 0.0412D0"<<endl;
  outfile<<"VCS      = 0.97344D0"<<endl;
  outfile<<"VCD      = 0.22520D0"<<endl;
  outfile<<"VUB      = 0.00351D0"<<endl;
  outfile<<"VUS      = 0.22534D0"<<endl;
  outfile<<"VUD      = 0.97427D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"  SCENARIO FOR ELW. CORRECTIONS TO H -> GG (EVERYTHING IN GEV):"<<endl;
  outfile<<"  GG_ELW = 1: MTP = 500    MBP = 450    MNUP = 375    MEP = 450"<<endl;
  outfile<<"  GG_ELW = 2: MBP = MNUP = MEP = 600    MTP = MBP+50*(1+LOG(M_H/115)/5)"<<endl<<endl;

  outfile<<"GG_ELW   = 1"<<endl;
  outfile<<"MTP      = 500.D0"<<endl;
  outfile<<"MBP      = 450.D0"<<endl;
  outfile<<"MNUP     = 375.D0"<<endl;
  outfile<<"MEP      = 450.D0"<<endl;
  outfile<<"************************** 2 Higgs Doublet Model *************************"<<endl;
  outfile<<"  TYPE: 1 (I), 2 (II), 3 (lepton-specific), 4 (flipped)"<<endl;
  outfile<<"  PARAM: 1 (masses), 2 (lambda_i)"<<endl<<endl;

  outfile<<"PARAM    = 1"<<endl;
  outfile<<"TYPE     = "<<fixed<<Type<<setprecision(8)<<endl;
  outfile<<"********************"<<endl;
  exponent=log10(abs(tanbeta));
  outfile<<"TGBET2HDM= "<<tanbeta/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(abs(m12sq));
  outfile<<"M_12^2   = "<<m12sq/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"******************** PARAM=1:"<<endl;
  exponent=log10(abs(alpha));
  outfile<<"ALPHA_H  = "<<alpha/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mHlight);
  outfile<<"MHL      = "<<mHlight/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mHheavy);
  outfile<<"MHH      = "<<mHheavy/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mA);
  outfile<<"MHA      = "<<mA/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mCharged);
  outfile<<"MH+-     = "<<mCharged/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"******************** PARAM=2:"<<endl;
  outfile<<"LAMBDA1  = 2.6885665050462264D0"<<endl;
  outfile<<"LAMBDA2  = 0.000156876030254505681D0"<<endl;
  outfile<<"LAMBDA3  = 0.46295674052962260D0"<<endl;
  outfile<<"LAMBDA4  = 0.96605498373771792D0"<<endl;
  outfile<<"LAMBDA5  = -0.88138084173680198D0"<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"SUSYSCALE= 1000.D0"<<endl;
  outfile<<"MU       = 1000.D0"<<endl;
  outfile<<"M2       = 1000.D0"<<endl;
  outfile<<"MGLUINO  = 1000.D0"<<endl;
  outfile<<"MSL1     = 1000.D0"<<endl;
  outfile<<"MER1     = 1000.D0"<<endl;
  outfile<<"MQL1     = 1000.D0"<<endl;
  outfile<<"MUR1     = 1000.D0"<<endl;
  outfile<<"MDR1     = 1000.D0"<<endl;
  outfile<<"MSL      = 1000.D0"<<endl;
  outfile<<"MER      = 1000.D0"<<endl;
  outfile<<"MSQ      = 1000.D0"<<endl;
  outfile<<"MUR      = 1000.D0"<<endl;
  outfile<<"MDR      = 1000.D0"<<endl;
  outfile<<"AL       = 1000.D0"<<endl;
  outfile<<"AU       = 1000.D0"<<endl;
  outfile<<"AD       = 1000.D0"<<endl;
  outfile<<"ON-SHELL = 0"<<endl;
  outfile<<"ON-SH-WZ = 0"<<endl;
  outfile<<"IPOLE    = 0"<<endl;
  outfile<<"OFF-SUSY = 0"<<endl;
  outfile<<"INDIDEC  = 0"<<endl;
  outfile<<"NF-GG    = 5"<<endl;
  outfile<<"IGOLD    = 0"<<endl;
  outfile<<"MPLANCK  = 2.4D18"<<endl;
  outfile<<"MGOLD    = 1.D-13"<<endl;
  outfile<<"******************* VARIATION OF HIGGS COUPLINGS *************************"<<endl;
  outfile<<"ELWK     = 0"<<endl;
  outfile<<"CW       = 1.D0"<<endl;
  outfile<<"CZ       = 1.D0"<<endl;
  outfile<<"Ctau     = 1.D0"<<endl;
  outfile<<"Cmu      = 1.D0"<<endl;
  outfile<<"Ct       = 1.D0"<<endl;
  outfile<<"Cb       = 1.D0"<<endl;
  outfile<<"Cc       = 1.D0"<<endl;
  outfile<<"Cs       = 1.D0"<<endl;
  outfile<<"Cgaga    = 0.D0"<<endl;
  outfile<<"Cgg      = 0.D0"<<endl;
  outfile<<"CZga     = 0.D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"Ctp      = 1.D0"<<endl;
  outfile<<"Cbp      = 1.D0"<<endl;
  outfile<<"Cnup     = 1.D0"<<endl;
  outfile<<"Cep      = 1.D0"<<endl;
#ifdef SHDECAYMODE
    //singlet stuff
  outfile<<"********************** real or complex singlet Model *********************"<<endl;
  outfile<<"Model: 1 - real broken phase, 2 - real dark matter phase"<<endl;
  outfile<<"       3 - complex broken phase, 4 - complex dark matter phase"<<endl;
  outfile<<"icxSM    = 4"<<endl;
  outfile<<"*** real singlet broken phase ***"<<endl;
  outfile<<"alph1    = -0.118574"<<endl;
  outfile<<"mH1      = 125.1D0"<<endl;
  outfile<<"mH2      = 306.361D0"<<endl;
  outfile<<"vs       = 293.222D0"<<endl;
  outfile<<"*** real singlet dark matter phase ***"<<endl;
  outfile<<"mH1      = 125.1D0"<<endl;
  outfile<<"mD       = 48.0215D0"<<endl;
  outfile<<"m2s      = -463128.D0"<<endl;
  outfile<<"lambdas  = 3.56328D0"<<endl;
  outfile<<"*** complex singlet broken phase ***"<<endl;
  outfile<<"alph1    = 0.160424D0"<<endl;
  outfile<<"alph2    = -0.362128D0"<<endl;
  outfile<<"alph3    = -0.552533D0"<<endl;
  outfile<<"m1       = 125.518D0"<<endl;
  outfile<<"m3       = 500.705D0"<<endl;
  outfile<<"vs       = 510.922D0"<<endl;
  outfile<<"*** complex singlet dark matter phase ***"<<endl;
  outfile<<"alph1    = -0.317120D0"<<endl;
  outfile<<"m1       = 125.3D0"<<endl;
  outfile<<"m2       = 400.D0"<<endl;
  outfile<<"m3       = 731.205D0"<<endl;
  outfile<<"vs       = 522.181D0"<<endl;
  outfile<<"a1       = -3.12115D07"<<endl;
#endif 
  
  outfile.close();

}

void CreateInputFileHdecaySM(double mH){
  ofstream outfile ; // ofstream output file object to write file;
#ifdef SHDECAYMODE
  outfile.open("shdecay.in"); 
#else
  outfile.open("hdecay.in");
#endif

  outfile<<"SLHAIN   = 0"<<endl;
  outfile<<"SLHAOUT  = 0"<<endl;
  outfile<<"COUPVAR  = 0"<<endl;
  outfile<<"HIGGS    = 0"<<endl;
  outfile<<"OMIT ELW = 1"<<endl;
  outfile<<"SM4      = 0"<<endl;
  outfile<<"FERMPHOB = 0"<<endl;
  outfile<<"2HDM     = 0"<<endl;
  outfile<<"MODEL    = 1"<<endl;
  outfile<<fixed<<setprecision(8);
  outfile<<"TGBET    = 30.D0"<<endl;
  int exponent=log10(mH);
  outfile<<"MABEG    = "<<mH/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"MAEND    = "<<mH/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"NMA      = 1"<<endl;
  outfile<<"********************* hMSSM (MODEL = 10) *********************************"<<endl;
  outfile<<"MHL      = 125.D0"<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"ALS(MZ)  = 0.118D0"<<endl;
  outfile<<"MSBAR(2) = 0.095D0"<<endl;
  outfile<<"MCBAR(3) = 0.986D0"<<endl;
  outfile<<"MBBAR(MB)= 4.180D0"<<endl;
  outfile<<"MT       = 172.5D0"<<endl;
  outfile<<"MTAU     = 1.77682D0"<<endl;
  outfile<<"MMUON    = 0.1056583715D0"<<endl;
  outfile<<"1/ALPHA  = 137.0359997D0"<<endl;
  outfile<<"GF       = 1.1663787D-5"<<endl;
  outfile<<"GAMW     = 2.08430D0"<<endl;
  outfile<<"GAMZ     = 2.49427D0"<<endl;
  outfile<<"MZ       = 91.15348D0"<<endl;
  outfile<<"MW       = 80.35797D0"<<endl;
  outfile<<"VTB      = 0.9991D0"<<endl;
  outfile<<"VTS      = 0.0404D0"<<endl;
  outfile<<"VTD      = 0.00867D0"<<endl;
  outfile<<"VCB      = 0.0412D0"<<endl;
  outfile<<"VCS      = 0.97344D0"<<endl;
  outfile<<"VCD      = 0.22520D0"<<endl;
  outfile<<"VUB      = 0.00351D0"<<endl;
  outfile<<"VUS      = 0.22534D0"<<endl;
  outfile<<"VUD      = 0.97427D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"  SCENARIO FOR ELW. CORRECTIONS TO H -> GG (EVERYTHING IN GEV):"<<endl;
  outfile<<"  GG_ELW = 1: MTP = 500    MBP = 450    MNUP = 375    MEP = 450"<<endl;
  outfile<<"  GG_ELW = 2: MBP = MNUP = MEP = 600    MTP = MBP+50*(1+LOG(M_H/115)/5)"<<endl<<endl;

  outfile<<"GG_ELW   = 1"<<endl;
  outfile<<"MTP      = 500.D0"<<endl;
  outfile<<"MBP      = 450.D0"<<endl;
  outfile<<"MNUP     = 375.D0"<<endl;
  outfile<<"MEP      = 450.D0"<<endl;
  outfile<<"************************** 2 Higgs Doublet Model *************************"<<endl;
  outfile<<"  TYPE: 1 (I), 2 (II), 3 (lepton-specific), 4 (flipped)"<<endl;
  outfile<<"  PARAM: 1 (masses), 2 (lambda_i)"<<endl<<endl;

  outfile<<"PARAM    = 1"<<endl;
  outfile<<"TYPE     = 1"<<endl;
  outfile<<"********************"<<endl;
  outfile<<"TGBET2HDM= 2.275D0"<<endl;
  outfile<<"M_12^2   = 3.045D3"<<endl;
  outfile<<"******************** PARAM=1:"<<endl;
  outfile<<"ALPHA_H  = -1.089D0"<<endl;
  exponent=log10(mH);
  outfile<<"MHL      = "<<mH/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"MHH      = 5.517D2"<<endl;
  outfile<<"MHA      = 2.915D2"<<endl;
  outfile<<"MH+-     = 4.682D2"<<endl;
  outfile<<"******************** PARAM=2:"<<endl;
  outfile<<"LAMBDA1  = 2.6885665050462264D0"<<endl;
  outfile<<"LAMBDA2  = 0.000156876030254505681D0"<<endl;
  outfile<<"LAMBDA3  = 0.46295674052962260D0"<<endl;
  outfile<<"LAMBDA4  = 0.96605498373771792D0"<<endl;
  outfile<<"LAMBDA5  = -0.88138084173680198D0"<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"SUSYSCALE= 1000.D0"<<endl;
  outfile<<"MU       = 1000.D0"<<endl;
  outfile<<"M2       = 1000.D0"<<endl;
  outfile<<"MGLUINO  = 1000.D0"<<endl;
  outfile<<"MSL1     = 1000.D0"<<endl;
  outfile<<"MER1     = 1000.D0"<<endl;
  outfile<<"MQL1     = 1000.D0"<<endl;
  outfile<<"MUR1     = 1000.D0"<<endl;
  outfile<<"MDR1     = 1000.D0"<<endl;
  outfile<<"MSL      = 1000.D0"<<endl;
  outfile<<"MER      = 1000.D0"<<endl;
  outfile<<"MSQ      = 1000.D0"<<endl;
  outfile<<"MUR      = 1000.D0"<<endl;
  outfile<<"MDR      = 1000.D0"<<endl;
  outfile<<"AL       = 1000.D0"<<endl;
  outfile<<"AU       = 1000.D0"<<endl;
  outfile<<"AD       = 1000.D0"<<endl;
  outfile<<"NNLO (M) = 0"<<endl;
  outfile<<"ON-SHELL = 0"<<endl;
  outfile<<"ON-SH-WZ = 0"<<endl;
  outfile<<"IPOLE    = 0"<<endl;
  outfile<<"OFF-SUSY = 0"<<endl;
  outfile<<"INDIDEC  = 0"<<endl;
  outfile<<"NF-GG    = 5"<<endl;
  outfile<<"IGOLD    = 0"<<endl;
  outfile<<"MPLANCK  = 2.4D18"<<endl;
  outfile<<"MGOLD    = 1.D-13"<<endl;
  outfile<<"******************* VARIATION OF HIGGS COUPLINGS *************************"<<endl;
  outfile<<"ELWK     = 0"<<endl;
  outfile<<"CW       = 1.D0"<<endl;
  outfile<<"CZ       = 1.D0"<<endl;
  outfile<<"Ctau     = 1.D0"<<endl;
  outfile<<"Cmu      = 1.D0"<<endl;
  outfile<<"Ct       = 1.D0"<<endl;
  outfile<<"Cb       = 1.D0"<<endl;
  outfile<<"Cc       = 1.D0"<<endl;
  outfile<<"Cs       = 1.D0"<<endl;
  outfile<<"Cgaga    = 0.D0"<<endl;
  outfile<<"Cgg      = 0.D0"<<endl;
  outfile<<"CZga     = 0.D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"Ctp      = 1.D0"<<endl;
  outfile<<"Cbp      = 1.D0"<<endl;
  outfile<<"Cnup     = 1.D0"<<endl;
  outfile<<"Cep      = 1.D0"<<endl;
#ifdef SHDECAYMODE
    //singlet stuff
  outfile<<"********************** real or complex singlet Model *********************"<<endl;

  outfile<<"Singlet Extension: 1 - yes, 0 - no (based on SM w/o EW corrections)"<<endl;
  outfile<<"Model: 1 - real broken phase, 2 - real dark matter phase"<<endl;
  outfile<<"       3 - complex broken phase, 4 - complex dark matter phase"<<endl;
  outfile<<"isinglet = 0"<<endl;
  outfile<<"icxSM    = 4"<<endl;
  outfile<<"*** real singlet broken phase ***"<<endl;
  outfile<<"alph1    = -0.118574"<<endl;
  outfile<<"mH1      = 125.1D0"<<endl;
  outfile<<"mH2      = 306.361D0"<<endl;
  outfile<<"vs       = 293.222D0"<<endl;
  outfile<<"*** real singlet dark matter phase ***"<<endl;
  outfile<<"mH1      = 125.1D0"<<endl;
  outfile<<"mD       = 48.0215D0"<<endl;
  outfile<<"m2s      = -463128.D0"<<endl;
  outfile<<"lambdas  = 3.56328D0"<<endl;
  outfile<<"*** complex singlet broken phase ***"<<endl;
  outfile<<"alph1    = 0.160424D0"<<endl;
  outfile<<"alph2    = -0.362128D0"<<endl;
  outfile<<"alph3    = -0.552533D0"<<endl;
  outfile<<"m1       = 125.518D0"<<endl;
  outfile<<"m3       = 500.705D0"<<endl;
  outfile<<"vs       = 510.922D0"<<endl;
  outfile<<"*** complex singlet dark matter phase ***"<<endl;
  outfile<<"alph1    = -0.317120D0"<<endl;
  outfile<<"m1       = 125.3D0"<<endl;
  outfile<<"m2       = 400.D0"<<endl;
  outfile<<"m3       = 731.205D0"<<endl;
  outfile<<"vs       = 522.181D0"<<endl;
  outfile<<"a1       = -3.12115D07"<<endl;
#endif 
  
  
  outfile.close();

}

//--------------------------------------
//--------------- N2HDM ----------------
//--------------------------------------

void CreateInputFileHdecayN2HDM(int Type, double tanbeta, double a1, double a2, double a3, double mH1,double mH2, double mH3, double mA, double mHc, double m12sq, double vevs){
  ofstream outfile ; // ofstream output file object to write file;
  outfile.open("n2hdecay.in");
  outfile<<"SLHAIN   = 0"<<endl;
  outfile<<"SLHAOUT  = 0"<<endl;
  outfile<<"COUPVAR  = 0"<<endl;
  outfile<<"HIGGS    = 5"<<endl;
  outfile<<"OMIT ELW = 0"<<endl;//only for SM, everything else without ew corr by default
  outfile<<"SM4      = 0"<<endl;
  outfile<<"FERMPHOB = 0"<<endl;
  outfile<<"2HDM     = 1"<<endl;
  outfile<<"N2HDM    = 1"<<endl;
  outfile<<"MODEL    = 1"<<endl;
  outfile<<fixed<<setprecision(8);
  int exponent=log10(abs(tanbeta));
  outfile<<"TGBET    = "<<tanbeta/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"MABEG    = 125.D0"<<endl;
  outfile<<"MAEND    = 1000.D0"<<endl;
  outfile<<"NMA      = 1"<<endl;
  outfile<<"********************* hMSSM (MODEL = 10) ********************************* "<<endl;
  outfile<<"MHL      = 1.250000e+02 "<<endl;
  outfile<<"************************************************************************** "<<endl;
  outfile<<"ALS(MZ)  = 0.118D0"<<endl;
  outfile<<"MSBAR(2) = 0.095D0"<<endl;
  outfile<<"MCBAR(3) = 0.986D0"<<endl;
  outfile<<"MBBAR(MB)= 4.180D0"<<endl;
  outfile<<"MT       = 172.5D0"<<endl;
  outfile<<"MTAU     = 1.77682D0"<<endl;
  outfile<<"MMUON    = 0.1056583715D0"<<endl;
  outfile<<"1/ALPHA  = 137.0359997D0"<<endl;
  outfile<<"GF       = 1.1663787D-5"<<endl;
  outfile<<"GAMW     = 2.08430D0"<<endl;
  outfile<<"GAMZ     = 2.49427D0"<<endl;
  outfile<<"MZ       = 91.15348D0"<<endl;
  outfile<<"MW       = 80.35797D0"<<endl;
  outfile<<"VTB      = 0.9991D0"<<endl;
  outfile<<"VTS      = 0.0404D0"<<endl;
  outfile<<"VTD      = 0.00867D0"<<endl;
  outfile<<"VCB      = 0.0412D0"<<endl;
  outfile<<"VCS      = 0.97344D0"<<endl;
  outfile<<"VCD      = 0.22520D0"<<endl;
  outfile<<"VUB      = 0.00351D0"<<endl;
  outfile<<"VUS      = 0.22534D0"<<endl;
  outfile<<"VUD      = 0.97427D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"  SCENARIO FOR ELW. CORRECTIONS TO H -> GG (EVERYTHING IN GEV):"<<endl;
  outfile<<"  GG_ELW = 1: MTP = 500    MBP = 450    MNUP = 375    MEP = 450"<<endl;
  outfile<<"  GG_ELW = 2: MBP = MNUP = MEP = 600    MTP = MBP+50*(1+LOG(M_H/115)/5)"<<endl<<endl;

  outfile<<"GG_ELW   = 1"<<endl;
  outfile<<"MTP      = 500.D0"<<endl;
  outfile<<"MBP      = 450.D0"<<endl;
  outfile<<"MNUP     = 375.D0"<<endl;
  outfile<<"MEP      = 450.D0"<<endl;
  outfile<<"************************** 2 Higgs Doublet Model *************************"<<endl;
  outfile<<"  TYPE: 1 (I), 2 (II), 3 (lepton-specific), 4 (flipped)"<<endl;
  outfile<<"  PARAM: 1 (masses), 2 (lambda_i)"<<endl<<endl;

  outfile<<"PARAM    = 1"<<endl;
  outfile<<"TYPE     = "<<Type<<endl;
  outfile<<"********************"<<endl;
  exponent=log10(abs(tanbeta));
  outfile<<"TGBET2HDM= "<<tanbeta/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(abs(m12sq));
  outfile<<"M_12^2   = "<<m12sq/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"******************** PARAM=1:"<<endl;
  outfile<<"ALPHA_H  = 10.D0"<<endl;//not used
  outfile<<"MHL      = 10.D0"<<endl;//not used
  outfile<<"MHH      = 10.D0"<<endl;//not used
  exponent=log10(mA);
  outfile<<"MHA      = "<<mA/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mHc);
  outfile<<"MH+-     = "<<mHc/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"******************** PARAM=2:"<<endl;
  outfile<<"LAMBDA1  = 0D0"<<endl;
  outfile<<"LAMBDA2  = 0D0"<<endl;
  outfile<<"LAMBDA3  = 0D0"<<endl;
  outfile<<"LAMBDA4  = 0D0"<<endl;
  outfile<<"LAMBDA5  = 0D0"<<endl;
  outfile<<"**************************** N2HDM ***********************************"<<endl;
  outfile<<"*** needs TYPE, TGBET2HDM, M12^2, MHA and MH+- from the 2HDM block ***"<<endl;
  exponent=log10(mH1);
  outfile<<"MH1      = "<<mH1/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH2);
  outfile<<"MH2      = "<<mH2/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH3);
  outfile<<"MH3      = "<<mH3/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"alpha1  = "<<a1<<endl;
  outfile<<"alpha2  = "<<a2<<endl;
  outfile<<"alpha3  = "<<a3<<endl;
  exponent=log10(abs(vevs));
  outfile<< "V_SING   = "<<vevs/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"SUSYSCALE= 1000.D0"<<endl;
  outfile<<"MU       = 1000.D0"<<endl;
  outfile<<"M2       = 1000.D0"<<endl;
  outfile<<"MGLUINO  = 1000.D0"<<endl;
  outfile<<"MSL1     = 1000.D0"<<endl;
  outfile<<"MER1     = 1000.D0"<<endl;
  outfile<<"MQL1     = 1000.D0"<<endl;
  outfile<<"MUR1     = 1000.D0"<<endl;
  outfile<<"MDR1     = 1000.D0"<<endl;
  outfile<<"MSL      = 1000.D0"<<endl;
  outfile<<"MER      = 1000.D0"<<endl;
  outfile<<"MSQ      = 1000.D0"<<endl;
  outfile<<"MUR      = 1000.D0"<<endl;
  outfile<<"MDR      = 1000.D0"<<endl;
  outfile<<"AL       = 1000.D0"<<endl;
  outfile<<"AU       = 1000.D0"<<endl;
  outfile<<"AD       = 1000.D0"<<endl;
  outfile<<"ON-SHELL = 0"<<endl;
  outfile<<"ON-SH-WZ = 0"<<endl;
  outfile<<"IPOLE    = 0"<<endl;
  outfile<<"OFF-SUSY = 0"<<endl;
  outfile<<"INDIDEC  = 0"<<endl;
  outfile<<"NF-GG    = 5"<<endl;
  outfile<<"IGOLD    = 0"<<endl;
  outfile<<"MPLANCK  = 2.4D18"<<endl;
  outfile<<"MGOLD    = 1.D-13"<<endl;
  outfile<<"******************* VARIATION OF HIGGS COUPLINGS *************************"<<endl;
  outfile<<"ELWK     = 0"<<endl;
  outfile<<"CW       = 1.D0"<<endl;
  outfile<<"CZ       = 1.D0"<<endl;
  outfile<<"Ctau     = 1.D0"<<endl;
  outfile<<"Cmu      = 1.D0"<<endl;
  outfile<<"Ct       = 1.D0"<<endl;
  outfile<<"Cb       = 1.D0"<<endl;
  outfile<<"Cc       = 1.D0"<<endl;
  outfile<<"Cs       = 1.D0"<<endl;
  outfile<<"Cgaga    = 0.D0"<<endl;
  outfile<<"Cgg      = 0.D0"<<endl;
  outfile<<"CZga     = 0.D0"<<endl;
  outfile<< "********************* 4TH GENERATION *************************************\n";
	outfile<< "Ctp      = 1.D0 " << std::endl;
	outfile<< "Cbp      = 1.D0 " << std::endl;
	outfile<< "Cnup     = 1.D0 " << std::endl;
	outfile<< "Cep      = 1.D0 " << std::endl;

  outfile.close();

}

void HdecayCalcN2HDM(std::map<std::string,double> & HdecayH1,std::map<std::string,double> & HdecayH2,std::map<std::string,double> & HdecayH3,std::map<std::string,double> & HdecayA,std::map<std::string,double> & HdecayHc,std::map<std::string,double> & HdecayTop){
  double h1_val[16],h2_val[17],h3_val[19],a_val[14],hc_val[15],top_val[3];
  hdecaycalln2hdm_(h1_val,h2_val,h3_val,a_val,hc_val,top_val);

//fill the maps with the values from hdecay
  // H1
  HdecayH1["Width"]=h1_val[0];
  HdecayH1["BR(H1 -> t tbar)"]=h1_val[1]; // always = 0 (as min(mH)<=125)
  HdecayH1["BR(H1 -> b bbar)"]=h1_val[2];
  HdecayH1["BR(H1 -> tau+ tau-)"]=h1_val[3];
  HdecayH1["BR(H1 -> c cbar)"]=h1_val[4];
  HdecayH1["BR(H1 -> s sbar)"]=h1_val[5];
  HdecayH1["BR(H1 -> mu+ mu-)"]=h1_val[6];
  HdecayH1["BR(H1 -> g g)"]=h1_val[7];
  HdecayH1["BR(H1 -> gamma gamma)"]=h1_val[8];
  HdecayH1["BR(H1 -> Z gamma)"]=h1_val[9];
  HdecayH1["BR(H1 -> W+ W-)"]=h1_val[10];
  HdecayH1["BR(H1 -> Z Z)"]=h1_val[11];
  HdecayH1["BR(H1 -> W+ H-)+BR(H1 -> W- H+)"]=h1_val[12]; // always = 0
  HdecayH1["BR(H1 -> Z A)"]=h1_val[13];
  HdecayH1["BR(H1 -> H+ H-)"]=h1_val[14]; // always = 0
  HdecayH1["BR(H1 -> A A)"]=h1_val[15];

  // H2
  HdecayH2["Width"]=h2_val[0];
  HdecayH2["BR(H2 -> t tbar)"]=h2_val[1];
  HdecayH2["BR(H2 -> b bbar)"]=h2_val[2];
  HdecayH2["BR(H2 -> tau+ tau-)"]=h2_val[3];
  HdecayH2["BR(H2 -> c cbar)"]=h2_val[4];
  HdecayH2["BR(H2 -> s sbar)"]=h2_val[5];
  HdecayH2["BR(H2 -> mu+ mu-)"]=h2_val[6];
  HdecayH2["BR(H2 -> g g)"]=h2_val[7];
  HdecayH2["BR(H2 -> gamma gamma)"]=h2_val[8];
  HdecayH2["BR(H2 -> Z gamma)"]=h2_val[9];
  HdecayH2["BR(H2 -> W+ W-)"]=h2_val[10];
  HdecayH2["BR(H2 -> Z Z)"]=h2_val[11];
  HdecayH2["BR(H2 -> W+ H-)+BR(H2 -> W- H+)"]=h2_val[12];
  HdecayH2["BR(H2 -> Z A)"]=h2_val[13];
  HdecayH2["BR(H2 -> H+ H-)"]=h2_val[14];
  HdecayH2["BR(H2 -> A A)"]=h2_val[15];
  HdecayH2["BR(H2 -> H1 H1)"]=h2_val[16];

  // H3
  HdecayH3["Width"]=h3_val[0];
  HdecayH3["BR(H3 -> t tbar)"]=h3_val[1];
  HdecayH3["BR(H3 -> b bbar)"]=h3_val[2];
  HdecayH3["BR(H3 -> tau+ tau-)"]=h3_val[3];
  HdecayH3["BR(H3 -> c cbar)"]=h3_val[4];
  HdecayH3["BR(H3 -> s sbar)"]=h3_val[5];
  HdecayH3["BR(H3 -> mu+ mu-)"]=h3_val[6];
  HdecayH3["BR(H3 -> g g)"]=h3_val[7];
  HdecayH3["BR(H3 -> gamma gamma)"]=h3_val[8];
  HdecayH3["BR(H3 -> Z gamma)"]=h3_val[9];
  HdecayH3["BR(H3 -> W+ W-)"]=h3_val[10];
  HdecayH3["BR(H3 -> Z Z)"]=h3_val[11];
  HdecayH3["BR(H3 -> W+ H-)+BR(H3 -> W- H+)"]=h3_val[12];
  HdecayH3["BR(H3 -> Z A)"]=h3_val[13];
  HdecayH3["BR(H3 -> H+ H-)"]=h3_val[14];
  HdecayH3["BR(H3 -> A A)"]=h3_val[15];
  HdecayH3["BR(H3 -> H1 H1)"]=h3_val[16];
  HdecayH3["BR(H3 -> H2 H2)"]=h3_val[17];
  HdecayH3["BR(H3 -> H1 H2)"]=h3_val[18];

  // A
  HdecayA["Width"]=a_val[0];
  HdecayA["BR(A -> t tbar)"]=a_val[1];
  HdecayA["BR(A -> b bbar)"]=a_val[2];
  HdecayA["BR(A -> tau+ tau-)"]=a_val[3];
  HdecayA["BR(A -> c cbar)"]=a_val[4];
  HdecayA["BR(A -> s sbar)"]=a_val[5];
  HdecayA["BR(A -> mu+ mu-)"]=a_val[6];
  HdecayA["BR(A -> g g)"]=a_val[7];
  HdecayA["BR(A -> gamma gamma)"]=a_val[8];
  HdecayA["BR(A -> Z gamma)"]=a_val[9];
  HdecayA["BR(A -> W+ H-)"]=a_val[10];
  HdecayA["BR(A -> Z H1)"]=a_val[11];
  HdecayA["BR(A -> Z H2)"]=a_val[12];
  HdecayA["BR(A -> Z H3)"]=a_val[13];

  // H+
  HdecayHc["Width"]=hc_val[0];
  HdecayHc["BR(H+ -> t bbar)"]=hc_val[1];
  HdecayHc["BR(H+ -> t sbar)"]=hc_val[2];
  HdecayHc["BR(H+ -> t dbar)"]=hc_val[3];
  HdecayHc["BR(H+ -> c bbar)"]=hc_val[4];
  HdecayHc["BR(H+ -> c sbar)"]=hc_val[5];
  HdecayHc["BR(H+ -> c dbar)"]=hc_val[6];
  HdecayHc["BR(H+ -> u bbar)"]=hc_val[7];
  HdecayHc["BR(H+ -> u sbar)"]=hc_val[8];
  HdecayHc["BR(H+ -> tau+ nu_tau)"]=hc_val[9];
  HdecayHc["BR(H+ -> mu+ nu_mu)"]=hc_val[10];
  HdecayHc["BR(H+ -> W+ A)"]=hc_val[11];
  HdecayHc["BR(H+ -> W+ H1)"]=hc_val[12];
  HdecayHc["BR(H+ -> W+ H2)"]=hc_val[13];
  HdecayHc["BR(H+ -> W+ H3)"]=hc_val[14];

  //Top
  HdecayTop["Width"]=top_val[0];
  HdecayTop["BR(t -> b W+)"]=top_val[1];
  HdecayTop["BR(t -> b H+)"]=top_val[2];
}


void CreateInputFileHdecayRsinglet(double mH1,double mH2,double alph1,double vs,double m2s,double lambdas,int type){
  ofstream outfile ; // ofstream output file object to write file;
  outfile.open("shdecay.in"); //open file named "shdecay.in" in the current directory

  outfile<<"SLHAIN   = 0"<<endl;
  outfile<<"SLHAOUT  = 0"<<endl;
  outfile<<"COUPVAR  = 0"<<endl;
  outfile<<"HIGGS    = 0"<<endl;
  outfile<<"OMIT ELW = 1"<<endl;
  outfile<<"SM4      = 0"<<endl;
  outfile<<"FERMPHOB = 0"<<endl;
  outfile<<"2HDM     = 0"<<endl;
  outfile<<"MODEL    = 1"<<endl;
  outfile<<fixed<<setprecision(8);
  outfile<<"TGBET    = 30.D0"<<endl;
  outfile<<"MABEG    = 125.D0"<<endl;
  outfile<<"MAEND    = 1000.D0"<<endl;
  outfile<<"NMA      = 1"<<endl;
  outfile<<"********************* hMSSM (MODEL = 10) *********************************"<<endl;
  outfile<<"MHL      = 125.D0"<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"ALS(MZ)  = 0.118D0"<<endl;
  outfile<<"MSBAR(2) = 0.095D0"<<endl;
  outfile<<"MCBAR(3) = 0.986D0"<<endl;
  outfile<<"MBBAR(MB)= 4.180D0"<<endl;
  outfile<<"MT       = 172.5D0"<<endl;
  outfile<<"MTAU     = 1.77682D0"<<endl;
  outfile<<"MMUON    = 0.1056583715D0"<<endl;
  outfile<<"1/ALPHA  = 137.0359997D0"<<endl;
  outfile<<"GF       = 1.1663787D-5"<<endl;
  outfile<<"GAMW     = 2.08430D0"<<endl;
  outfile<<"GAMZ     = 2.49427D0"<<endl;
  outfile<<"MZ       = 91.15348D0"<<endl;
  outfile<<"MW       = 80.35797D0"<<endl;
  outfile<<"VTB      = 0.9991D0"<<endl;
  outfile<<"VTS      = 0.0404D0"<<endl;
  outfile<<"VTD      = 0.00867D0"<<endl;
  outfile<<"VCB      = 0.0412D0"<<endl;
  outfile<<"VCS      = 0.97344D0"<<endl;
  outfile<<"VCD      = 0.22520D0"<<endl;
  outfile<<"VUB      = 0.00351D0"<<endl;
  outfile<<"VUS      = 0.22534D0"<<endl;
  outfile<<"VUD      = 0.97427D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"  SCENARIO FOR ELW. CORRECTIONS TO H -> GG (EVERYTHING IN GEV):"<<endl;
  outfile<<"  GG_ELW = 1: MTP = 500    MBP = 450    MNUP = 375    MEP = 450"<<endl;
  outfile<<"  GG_ELW = 2: MBP = MNUP = MEP = 600    MTP = MBP+50*(1+LOG(M_H/115)/5)"<<endl<<endl;

  outfile<<"GG_ELW   = 1"<<endl;
  outfile<<"MTP      = 500.D0"<<endl;
  outfile<<"MBP      = 450.D0"<<endl;
  outfile<<"MNUP     = 375.D0"<<endl;
  outfile<<"MEP      = 450.D0"<<endl;
  outfile<<"************************** 2 Higgs Doublet Model *************************"<<endl;
  outfile<<"  TYPE: 1 (I), 2 (II), 3 (lepton-specific), 4 (flipped)"<<endl;
  outfile<<"  PARAM: 1 (masses), 2 (lambda_i)"<<endl<<endl;

  outfile<<"PARAM    = 1"<<endl;
  outfile<<"TYPE     = 1"<<endl;
  outfile<<"********************"<<endl;
  outfile<<"TGBET2HDM= 2.275D0"<<endl;
  outfile<<"M_12^2   = 3.045D3"<<endl;
  outfile<<"******************** PARAM=1:"<<endl;
  outfile<<"ALPHA_H  = -1.089D0"<<endl;

  outfile<<"MHL      = 5.517D2"<<endl;
  outfile<<"MHH      = 5.517D2"<<endl;
  outfile<<"MHA      = 2.915D2"<<endl;
  outfile<<"MH+-     = 4.682D2"<<endl;
  outfile<<"******************** PARAM=2:"<<endl;
  outfile<<"LAMBDA1  = 2.6885665050462264D0"<<endl;
  outfile<<"LAMBDA2  = 0.000156876030254505681D0"<<endl;
  outfile<<"LAMBDA3  = 0.46295674052962260D0"<<endl;
  outfile<<"LAMBDA4  = 0.96605498373771792D0"<<endl;
  outfile<<"LAMBDA5  = -0.88138084173680198D0"<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"SUSYSCALE= 1000.D0"<<endl;
  outfile<<"MU       = 1000.D0"<<endl;
  outfile<<"M2       = 1000.D0"<<endl;
  outfile<<"MGLUINO  = 1000.D0"<<endl;
  outfile<<"MSL1     = 1000.D0"<<endl;
  outfile<<"MER1     = 1000.D0"<<endl;
  outfile<<"MQL1     = 1000.D0"<<endl;
  outfile<<"MUR1     = 1000.D0"<<endl;
  outfile<<"MDR1     = 1000.D0"<<endl;
  outfile<<"MSL      = 1000.D0"<<endl;
  outfile<<"MER      = 1000.D0"<<endl;
  outfile<<"MSQ      = 1000.D0"<<endl;
  outfile<<"MUR      = 1000.D0"<<endl;
  outfile<<"MDR      = 1000.D0"<<endl;
  outfile<<"AL       = 1000.D0"<<endl;
  outfile<<"AU       = 1000.D0"<<endl;
  outfile<<"AD       = 1000.D0"<<endl;
  outfile<<"NNLO (M) = 0"<<endl;
  outfile<<"ON-SHELL = 0"<<endl;
  outfile<<"ON-SH-WZ = 0"<<endl;
  outfile<<"IPOLE    = 0"<<endl;
  outfile<<"OFF-SUSY = 0"<<endl;
  outfile<<"INDIDEC  = 0"<<endl;
  outfile<<"NF-GG    = 5"<<endl;
  outfile<<"IGOLD    = 0"<<endl;
  outfile<<"MPLANCK  = 2.4D18"<<endl;
  outfile<<"MGOLD    = 1.D-13"<<endl;
  outfile<<"******************* VARIATION OF HIGGS COUPLINGS *************************"<<endl;
  outfile<<"ELWK     = 0"<<endl;
  outfile<<"CW       = 1.D0"<<endl;
  outfile<<"CZ       = 1.D0"<<endl;
  outfile<<"Ctau     = 1.D0"<<endl;
  outfile<<"Cmu      = 1.D0"<<endl;
  outfile<<"Ct       = 1.D0"<<endl;
  outfile<<"Cb       = 1.D0"<<endl;
  outfile<<"Cc       = 1.D0"<<endl;
  outfile<<"Cs       = 1.D0"<<endl;
  outfile<<"Cgaga    = 0.D0"<<endl;
  outfile<<"Cgg      = 0.D0"<<endl;
  outfile<<"CZga     = 0.D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"Ctp      = 1.D0"<<endl;
  outfile<<"Cbp      = 1.D0"<<endl;
  outfile<<"Cnup     = 1.D0"<<endl;
  outfile<<"Cep      = 1.D0"<<endl;
  //singlet stuff
  outfile<<"********************** real or complex singlet Model *********************"<<endl;
  outfile<<"Singlet Extension: 1 - yes, 0 - no (based on SM w/o EW corrections)"<<endl;
  outfile<<"Model: 1 - real broken phase, 2 - real dark matter phase"<<endl;
  outfile<<"       3 - complex broken phase, 4 - complex dark matter phase"<<endl;
  outfile<<"isinglet = 1"<<endl;
  outfile<<"icxSM    = "<<type<<endl;
  outfile<<"*** real singlet broken phase ***"<<endl;
  int exponent=log10(abs(alph1));
  if(alph1==0)
    exponent=0;
  outfile<<"alph1    = "<<alph1/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH1);
  outfile<<"mH1      = "<<mH1/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH2);
  outfile<<"mH2      = "<<mH2/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(vs);
  if(vs==0)
    exponent=0;
  outfile<<"vs       = "<<vs/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"*** real singlet dark matter phase ***"<<endl;
  exponent=log10(mH1);
  outfile<<"mH1      = "<<mH1/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH2);
  outfile<<"mD       = "<<mH2/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(abs(m2s));
  outfile<<"m2s      = "<<m2s/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(abs(lambdas));
  outfile<<"lambdas  = "<<lambdas/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"*** complex singlet broken phase ***"<<endl;
  outfile<<"alph1    = 0.160424D0"<<endl;
  outfile<<"alph2    = -0.362128D0"<<endl;
  outfile<<"alph3    = -0.552533D0"<<endl;
  outfile<<"m1       = 125.518D0"<<endl;
  outfile<<"m3       = 500.705D0"<<endl;
  outfile<<"vs       = 510.922D0"<<endl;
  outfile<<"*** complex singlet dark matter phase ***"<<endl;
  outfile<<"alph1    = -0.317120D0"<<endl;
  outfile<<"m1       = 125.3D0"<<endl;
  outfile<<"m2       = 400.D0"<<endl;
  outfile<<"m3       = 731.205D0"<<endl;
  outfile<<"vs       = 522.181D0"<<endl;
  outfile<<"a1       = -3.12115D07"<<endl;
  
  outfile.close();
}

void CreateInputFileHdecayCsinglet(double mH1,double mH2,double mH3,double alph1,double alph2,double alph3,double vs,double a1,int type){
  ofstream outfile ; // ofstream output file object to write file;
  outfile.open("shdecay.in"); //open file named "tempsuperiso.lha" in the current directory

  outfile<<"SLHAIN   = 0"<<endl;
  outfile<<"SLHAOUT  = 0"<<endl;
  outfile<<"COUPVAR  = 0"<<endl;
  outfile<<"HIGGS    = 0"<<endl;
  outfile<<"OMIT ELW = 1"<<endl;
  outfile<<"SM4      = 0"<<endl;
  outfile<<"FERMPHOB = 0"<<endl;
  outfile<<"2HDM     = 0"<<endl;
  outfile<<"MODEL    = 1"<<endl;
  outfile<<fixed<<setprecision(8);
  outfile<<"TGBET    = 30.D0"<<endl;
  outfile<<"MABEG    = 125.D0"<<endl;
  outfile<<"MAEND    = 1000.D0"<<endl;
  outfile<<"NMA      = 1"<<endl;
  outfile<<"********************* hMSSM (MODEL = 10) *********************************"<<endl;
  outfile<<"MHL      = 125.D0"<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"ALS(MZ)  = 0.118D0"<<endl;
  outfile<<"MSBAR(2) = 0.095D0"<<endl;
  outfile<<"MCBAR(3) = 0.986D0"<<endl;
  outfile<<"MBBAR(MB)= 4.180D0"<<endl;
  outfile<<"MT       = 172.5D0"<<endl;
  outfile<<"MTAU     = 1.77682D0"<<endl;
  outfile<<"MMUON    = 0.1056583715D0"<<endl;
  outfile<<"1/ALPHA  = 137.0359997D0"<<endl;
  outfile<<"GF       = 1.1663787D-5"<<endl;
  outfile<<"GAMW     = 2.08430D0"<<endl;
  outfile<<"GAMZ     = 2.49427D0"<<endl;
  outfile<<"MZ       = 91.15348D0"<<endl;
  outfile<<"MW       = 80.35797D0"<<endl;
  outfile<<"VTB      = 0.9991D0"<<endl;
  outfile<<"VTS      = 0.0404D0"<<endl;
  outfile<<"VTD      = 0.00867D0"<<endl;
  outfile<<"VCB      = 0.0412D0"<<endl;
  outfile<<"VCS      = 0.97344D0"<<endl;
  outfile<<"VCD      = 0.22520D0"<<endl;
  outfile<<"VUB      = 0.00351D0"<<endl;
  outfile<<"VUS      = 0.22534D0"<<endl;
  outfile<<"VUD      = 0.97427D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"  SCENARIO FOR ELW. CORRECTIONS TO H -> GG (EVERYTHING IN GEV):"<<endl;
  outfile<<"  GG_ELW = 1: MTP = 500    MBP = 450    MNUP = 375    MEP = 450"<<endl;
  outfile<<"  GG_ELW = 2: MBP = MNUP = MEP = 600    MTP = MBP+50*(1+LOG(M_H/115)/5)"<<endl<<endl;

  outfile<<"GG_ELW   = 1"<<endl;
  outfile<<"MTP      = 500.D0"<<endl;
  outfile<<"MBP      = 450.D0"<<endl;
  outfile<<"MNUP     = 375.D0"<<endl;
  outfile<<"MEP      = 450.D0"<<endl;
  outfile<<"************************** 2 Higgs Doublet Model *************************"<<endl;
  outfile<<"  TYPE: 1 (I), 2 (II), 3 (lepton-specific), 4 (flipped)"<<endl;
  outfile<<"  PARAM: 1 (masses), 2 (lambda_i)"<<endl<<endl;

  outfile<<"PARAM    = 1"<<endl;
  outfile<<"TYPE     = 1"<<endl;
  outfile<<"********************"<<endl;
  outfile<<"TGBET2HDM= 2.275D0"<<endl;
  outfile<<"M_12^2   = 3.045D3"<<endl;
  outfile<<"******************** PARAM=1:"<<endl;
  outfile<<"ALPHA_H  = -1.089D0"<<endl;

  outfile<<"MHL      = 5.517D2"<<endl;
  outfile<<"MHH      = 5.517D2"<<endl;
  outfile<<"MHA      = 2.915D2"<<endl;
  outfile<<"MH+-     = 4.682D2"<<endl;
  outfile<<"******************** PARAM=2:"<<endl;
  outfile<<"LAMBDA1  = 2.6885665050462264D0"<<endl;
  outfile<<"LAMBDA2  = 0.000156876030254505681D0"<<endl;
  outfile<<"LAMBDA3  = 0.46295674052962260D0"<<endl;
  outfile<<"LAMBDA4  = 0.96605498373771792D0"<<endl;
  outfile<<"LAMBDA5  = -0.88138084173680198D0"<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"SUSYSCALE= 1000.D0"<<endl;
  outfile<<"MU       = 1000.D0"<<endl;
  outfile<<"M2       = 1000.D0"<<endl;
  outfile<<"MGLUINO  = 1000.D0"<<endl;
  outfile<<"MSL1     = 1000.D0"<<endl;
  outfile<<"MER1     = 1000.D0"<<endl;
  outfile<<"MQL1     = 1000.D0"<<endl;
  outfile<<"MUR1     = 1000.D0"<<endl;
  outfile<<"MDR1     = 1000.D0"<<endl;
  outfile<<"MSL      = 1000.D0"<<endl;
  outfile<<"MER      = 1000.D0"<<endl;
  outfile<<"MSQ      = 1000.D0"<<endl;
  outfile<<"MUR      = 1000.D0"<<endl;
  outfile<<"MDR      = 1000.D0"<<endl;
  outfile<<"AL       = 1000.D0"<<endl;
  outfile<<"AU       = 1000.D0"<<endl;
  outfile<<"AD       = 1000.D0"<<endl;
  outfile<<"NNLO (M) = 0"<<endl;
  outfile<<"ON-SHELL = 0"<<endl;
  outfile<<"ON-SH-WZ = 0"<<endl;
  outfile<<"IPOLE    = 0"<<endl;
  outfile<<"OFF-SUSY = 0"<<endl;
  outfile<<"INDIDEC  = 0"<<endl;
  outfile<<"NF-GG    = 5"<<endl;
  outfile<<"IGOLD    = 0"<<endl;
  outfile<<"MPLANCK  = 2.4D18"<<endl;
  outfile<<"MGOLD    = 1.D-13"<<endl;
  outfile<<"******************* VARIATION OF HIGGS COUPLINGS *************************"<<endl;
  outfile<<"ELWK     = 0"<<endl;
  outfile<<"CW       = 1.D0"<<endl;
  outfile<<"CZ       = 1.D0"<<endl;
  outfile<<"Ctau     = 1.D0"<<endl;
  outfile<<"Cmu      = 1.D0"<<endl;
  outfile<<"Ct       = 1.D0"<<endl;
  outfile<<"Cb       = 1.D0"<<endl;
  outfile<<"Cc       = 1.D0"<<endl;
  outfile<<"Cs       = 1.D0"<<endl;
  outfile<<"Cgaga    = 0.D0"<<endl;
  outfile<<"Cgg      = 0.D0"<<endl;
  outfile<<"CZga     = 0.D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"Ctp      = 1.D0"<<endl;
  outfile<<"Cbp      = 1.D0"<<endl;
  outfile<<"Cnup     = 1.D0"<<endl;
  outfile<<"Cep      = 1.D0"<<endl;
  //singlet stuff
  outfile<<"********************** real or complex singlet Model *********************"<<endl;
  outfile<<"Singlet Extension: 1 - yes, 0 - no (based on SM w/o EW corrections)"<<endl;
  outfile<<"Model: 1 - real broken phase, 2 - real dark matter phase"<<endl;
  outfile<<"       3 - complex broken phase, 4 - complex dark matter phase"<<endl;
  outfile<<"isinglet = 1"<<endl;
  outfile<<"icxSM    = "<<type<<endl;
  outfile<<"*** real singlet broken phase ***"<<endl;
  outfile<<"alph1    = -0.118574"<<endl;
  outfile<<"mH1      = 125.1D0"<<endl;
  outfile<<"mH2      = 306.361D0"<<endl;
  outfile<<"vs       = 293.222D0"<<endl;
  outfile<<"*** real singlet dark matter phase ***"<<endl;
  outfile<<"mH1      = 125.1D0"<<endl;
  outfile<<"mD       = 48.0215D0"<<endl;
  outfile<<"m2s      = -463128.D0"<<endl;
  outfile<<"lambdas  = 3.56328D0"<<endl;
  outfile<<"*** complex singlet broken phase ***"<<endl;
  int exponent=log10(abs(alph1));
  if(alph1==0)
    exponent=0;
  outfile<<"alph1    = "<<alph1/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(abs(alph2));
  if(alph2==0)
    exponent=0;
  outfile<<"alph2    = "<<alph2/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(abs(alph3));
  if(alph3==0)
    exponent=0;
  outfile<<"alph3    = "<<alph3/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH1);
  outfile<<"m1       = "<<mH1/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH3);
  outfile<<"m3       = "<<mH3/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(vs);
  if(vs==0)
    exponent=0;
  outfile<<"vs       = "<<vs/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"*** complex singlet dark matter phase ***"<<endl;
  exponent=log10(abs(alph1));
  outfile<<"alph1    = "<<alph1/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH1);
  outfile<<"m1       = "<<mH1/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH2);
  outfile<<"m2       = "<<mH2/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH3);
  outfile<<"m3       = "<<mH3/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(vs);
  if(vs==0)
    exponent=0;
  outfile<<"vs       = "<<vs/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(abs(a1));
  outfile<<"a1       = "<<a1/pow(10,exponent)<<"D"<<exponent<<endl;
  
  outfile.close();
}

void HdecayCalcSing(std::map<std::string,double> & HdecayHsing){
  //NOT DONE
  double SING1_BRB_out,SING1_BRL_out,SING1_BRM_out,SING1_BRS_out,SING1_BRC_out,SING1_BRT_out,SING1_BRG_out,SING1_BRGA_out,SING1_BRZGA_out,SING1_BRW_out,SING1_BRZ_out,SING1_WDTH_out,SING2_BRB_out,SING2_BRL_out,SING2_BRM_out,SING2_BRS_out,SING2_BRC_out,SING2_BRT_out,SING2_BRG_out,SING2_BRGA_out,SING2_BRZGA_out,SING2_BRW_out,SING2_BRZ_out,SING2_WDTH_out,SING3_BRB_out,SING3_BRL_out,SING3_BRM_out,SING3_BRS_out,SING3_BRC_out,SING3_BRT_out,SING3_BRG_out,SING3_BRGA_out,SING3_BRZGA_out,SING3_BRW_out,SING3_BRZ_out,SING3_WDTH_out,SING_BRH1H2H2_out,SING_BRH1H3H3_out,SING_BRH1H2H3_out,SING_BRH2H1H1_out,SING_BRH2H3H3_out,SING_BRH2H1H3_out,SING_BRH3H1H1_out,SING_BRH3H2H2_out,SING_BRH3H1H2_out;

  hdecaycallsinglets_(SING1_BRB_out,SING1_BRL_out,SING1_BRM_out,SING1_BRS_out,SING1_BRC_out,SING1_BRT_out,SING1_BRG_out,SING1_BRGA_out,SING1_BRZGA_out,SING1_BRW_out,SING1_BRZ_out,SING1_WDTH_out,SING2_BRB_out,SING2_BRL_out,SING2_BRM_out,SING2_BRS_out,SING2_BRC_out,SING2_BRT_out,SING2_BRG_out,SING2_BRGA_out,SING2_BRZGA_out,SING2_BRW_out,SING2_BRZ_out,SING2_WDTH_out,SING3_BRB_out,SING3_BRL_out,SING3_BRM_out,SING3_BRS_out,SING3_BRC_out,SING3_BRT_out,SING3_BRG_out,SING3_BRGA_out,SING3_BRZGA_out,SING3_BRW_out,SING3_BRZ_out,SING3_WDTH_out,SING_BRH1H2H2_out,SING_BRH1H3H3_out,SING_BRH1H2H3_out,SING_BRH2H1H1_out,SING_BRH2H3H3_out,SING_BRH2H1H3_out,SING_BRH3H1H1_out,SING_BRH3H2H2_out,SING_BRH3H1H2_out);


  HdecayHsing["BR(H1 -> b bbar)"]=SING1_BRB_out;
  HdecayHsing["BR(H1 -> tau+ tau-)"]=SING1_BRL_out;
  HdecayHsing["BR(H1 -> mu+ mu-)"]=SING1_BRM_out;
  HdecayHsing["BR(H1 -> s sbar)"]=SING1_BRS_out;
  HdecayHsing["BR(H1 -> c cbar)"]=SING1_BRC_out;
  HdecayHsing["BR(H1 -> t tbar)"]=SING1_BRT_out;
  HdecayHsing["BR(H1 -> g g)"]=SING1_BRG_out;
  HdecayHsing["BR(H1 -> gamma gamma)"]=SING1_BRGA_out;
  HdecayHsing["BR(H1 -> Z gamma)"]=SING1_BRZGA_out;
  HdecayHsing["BR(H1 -> W+ W-)"]=SING1_BRW_out;
  HdecayHsing["BR(H1 -> Z Z)"]=SING1_BRZ_out;
  HdecayHsing["H1Width"]=SING1_WDTH_out;

  HdecayHsing["BR(H2 -> b bbar)"]=SING2_BRB_out;
  HdecayHsing["BR(H2 -> tau+ tau-)"]=SING2_BRL_out;
  HdecayHsing["BR(H2 -> mu+ mu-)"]=SING2_BRM_out;
  HdecayHsing["BR(H2 -> s sbar)"]=SING2_BRS_out;
  HdecayHsing["BR(H2 -> c cbar)"]=SING2_BRC_out;
  HdecayHsing["BR(H2 -> t tbar)"]=SING2_BRT_out;
  HdecayHsing["BR(H2 -> g g)"]=SING2_BRG_out;
  HdecayHsing["BR(H2 -> gamma gamma)"]=SING2_BRGA_out;
  HdecayHsing["BR(H2 -> Z gamma)"]=SING2_BRZGA_out;
  HdecayHsing["BR(H2 -> W+ W-)"]=SING2_BRW_out;
  HdecayHsing["BR(H2 -> Z Z)"]=SING2_BRZ_out;
  HdecayHsing["H2Width"]=SING2_WDTH_out;

  HdecayHsing["BR(H3 -> b bbar)"]=SING3_BRB_out;
  HdecayHsing["BR(H3 -> tau+ tau-)"]=SING3_BRL_out;
  HdecayHsing["BR(H3 -> mu+ mu-)"]=SING3_BRM_out;
  HdecayHsing["BR(H3 -> s sbar)"]=SING3_BRS_out;
  HdecayHsing["BR(H3 -> c cbar)"]=SING3_BRC_out;
  HdecayHsing["BR(H3 -> t tbar)"]=SING3_BRT_out;
  HdecayHsing["BR(H3 -> g g)"]=SING3_BRG_out;
  HdecayHsing["BR(H3 -> gamma gamma)"]=SING3_BRGA_out;
  HdecayHsing["BR(H3 -> Z gamma)"]=SING3_BRZGA_out;
  HdecayHsing["BR(H3 -> W+ W-)"]=SING3_BRW_out;
  HdecayHsing["BR(H3 -> Z Z)"]=SING3_BRZ_out;
  HdecayHsing["H3Width"]=SING3_WDTH_out;


  HdecayHsing["BR(H1 -> H2 H2)"]=SING_BRH1H2H2_out;
  HdecayHsing["BR(H1 -> H3 H3)"]=SING_BRH1H3H3_out;
  HdecayHsing["BR(H1 -> H2 H3)"]=SING_BRH1H2H3_out;
  HdecayHsing["BR(H2 -> H1 H1)"]=SING_BRH2H1H1_out;
  HdecayHsing["BR(H2 -> H3 H3)"]=SING_BRH2H3H3_out;
  HdecayHsing["BR(H2 -> H1 H3)"]=SING_BRH2H1H3_out;
  HdecayHsing["BR(H3 -> H1 H1)"]=SING_BRH3H1H1_out;
  HdecayHsing["BR(H3 -> H2 H2)"]=SING_BRH3H2H2_out;
  HdecayHsing["BR(H3 -> H1 H2)"]=SING_BRH3H1H2_out;
}


//////////////////////////////////
//////////    C2HDM    ///////////
//////////////////////////////////

void CreateInputFileHdecayC2HDM(int Type, double tanbeta, double a1, double a2, double a3, double mH1, double mH2, double mHc, double re_m12sq){
  ofstream outfile("hdecay.in"); // ofstream output file object to write file;
  outfile<<"SLHAIN   = 0"<<endl;
  outfile<<"SLHAOUT  = 0"<<endl;
  outfile<<"COUPVAR  = 0"<<endl;
  outfile<<"HIGGS    = 5"<<endl;
  outfile<<"OMIT ELW = 0"<<endl;//only for SM, everything else without ew corr by default
  outfile<<"SM4      = 0"<<endl;
  outfile<<"FERMPHOB = 0"<<endl;
  outfile<<"2HDM     = 1"<<endl;
  outfile<<"C2HDM    = 1"<<endl;
  outfile<<"MODEL    = 1"<<endl;
  outfile<<fixed<<setprecision(8);
  outfile<<"TGBET    = 1.D0"<<endl;
  outfile<<"MABEG    = 125.D0"<<endl;
  outfile<<"MAEND    = 1000.D0"<<endl;
  outfile<<"NMA      = 1"<<endl;
  outfile<<"********************* hMSSM (MODEL = 10) ********************************* "<<endl;
  outfile<<"MHL      = 1.250000e+02 "<<endl;
  outfile<<"************************************************************************** "<<endl;
  outfile<<"ALS(MZ)  = 0.118D0"<<endl;
  outfile<<"MSBAR(2) = 0.095D0"<<endl;
  outfile<<"MCBAR(3) = 0.986D0"<<endl;
  outfile<<"MBBAR(MB)= 4.180D0"<<endl;
  outfile<<"MT       = 172.5D0"<<endl;
  outfile<<"MTAU     = 1.77682D0"<<endl;
  outfile<<"MMUON    = 0.1056583715D0"<<endl;
  outfile<<"1/ALPHA  = 137.0359997D0"<<endl;
  outfile<<"GF       = 1.1663787D-5"<<endl;
  outfile<<"GAMW     = 2.08430D0"<<endl;
  outfile<<"GAMZ     = 2.49427D0"<<endl;
  outfile<<"MZ       = 91.15348D0"<<endl;
  outfile<<"MW       = 80.35797D0"<<endl;
  outfile<<"VTB      = 0.9991D0"<<endl;
  outfile<<"VTS      = 0.0404D0"<<endl;
  outfile<<"VTD      = 0.00867D0"<<endl;
  outfile<<"VCB      = 0.0412D0"<<endl;
  outfile<<"VCS      = 0.97344D0"<<endl;
  outfile<<"VCD      = 0.22520D0"<<endl;
  outfile<<"VUB      = 0.00351D0"<<endl;
  outfile<<"VUS      = 0.22534D0"<<endl;
  outfile<<"VUD      = 0.97427D0"<<endl;
  outfile<<"********************* 4TH GENERATION *************************************"<<endl;
  outfile<<"  SCENARIO FOR ELW. CORRECTIONS TO H -> GG (EVERYTHING IN GEV):"<<endl;
  outfile<<"  GG_ELW = 1: MTP = 500    MBP = 450    MNUP = 375    MEP = 450"<<endl;
  outfile<<"  GG_ELW = 2: MBP = MNUP = MEP = 600    MTP = MBP+50*(1+LOG(M_H/115)/5)"<<endl<<endl;
  outfile<<"GG_ELW   = 1"<<endl;
  outfile<<"MTP      = 500.D0"<<endl;
  outfile<<"MBP      = 450.D0"<<endl;
  outfile<<"MNUP     = 375.D0"<<endl;
  outfile<<"MEP      = 450.D0"<<endl;
  outfile<<"************************** 2 Higgs Doublet Model *************************"<<endl;
  outfile<<"  TYPE: 1 (I), 2 (II), 3 (lepton-specific), 4 (flipped)"<<endl;
  outfile<<"  PARAM: 1 (masses), 2 (lambda_i)"<<endl<<endl;
  outfile<<"PARAM    = 1"<<endl;
  outfile<<"TYPE     = "<<Type<<endl;
  outfile<<"********************"<<endl;
  outfile<<"TGBET2HDM= 1.D0"<<endl;//not used
  outfile<<"M_12^2   = 1000.D0"<<endl;//not used
  outfile<<"******************** PARAM=1:"<<endl;
  outfile<<"ALPHA_H  = 14.D0"<<endl;//not used
  outfile<<"MHL      = 10.D0"<<endl;//not used
  outfile<<"MHH      = 11.D0"<<endl;//not used
  outfile<<"MHA      = 12.D0"<<endl;//not used
  outfile<<"MH+-     = 13.D0"<<endl;//not used
  outfile<<"******************** PARAM=2:"<<endl;
  outfile<<"LAMBDA1  = 0D0"<<endl;
  outfile<<"LAMBDA2  = 0D0"<<endl;
  outfile<<"LAMBDA3  = 0D0"<<endl;
  outfile<<"LAMBDA4  = 0D0"<<endl;
  outfile<<"LAMBDA5  = 0D0"<<endl;
  outfile<<"*********************** complex 2 Higgs Doublet Model ********************"<<endl;
  int exponent=log10(mH1);
  outfile<<"M1_2HDM  = "<<mH1/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mH2);
  outfile<<"M2_2HDM  = "<<mH2/pow(10,exponent)<<"D"<<exponent<<endl;
  exponent=log10(mHc);
  outfile<<"MCH_2HDM = "<<mHc/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"alp1_2HDM= "<<a1<<endl;
  outfile<<"alp2_2HDM= "<<a2<<endl;
  outfile<<"alp3_2HDM= "<<a3<<endl;
  outfile<<"tbetc2HDM= "<<tanbeta<<endl;
  exponent=log10(re_m12sq);
  outfile<<"R_M12_H2 = "<<re_m12sq/pow(10,exponent)<<"D"<<exponent<<endl;
  outfile<<"TYPE_cp  = "<<Type<<endl;
  outfile<<"**************************************************************************"<<endl;
  outfile<<"SUSYSCALE= 1000.D0"<<endl;
  outfile<<"MU       = 1000.D0"<<endl;
  outfile<<"M2       = 1000.D0"<<endl;
  outfile<<"MGLUINO  = 1000.D0"<<endl;
  outfile<<"MSL1     = 1000.D0"<<endl;
  outfile<<"MER1     = 1000.D0"<<endl;
  outfile<<"MQL1     = 1000.D0"<<endl;
  outfile<<"MUR1     = 1000.D0"<<endl;
  outfile<<"MDR1     = 1000.D0"<<endl;
  outfile<<"MSL      = 1000.D0"<<endl;
  outfile<<"MER      = 1000.D0"<<endl;
  outfile<<"MSQ      = 1000.D0"<<endl;
  outfile<<"MUR      = 1000.D0"<<endl;
  outfile<<"MDR      = 1000.D0"<<endl;
  outfile<<"AL       = 1000.D0"<<endl;
  outfile<<"AU       = 1000.D0"<<endl;
  outfile<<"AD       = 1000.D0"<<endl;
  outfile<<"ON-SHELL = 0"<<endl;
  outfile<<"ON-SH-WZ = 0"<<endl;
  outfile<<"IPOLE    = 0"<<endl;
  outfile<<"OFF-SUSY = 0"<<endl;
  outfile<<"INDIDEC  = 0"<<endl;
  outfile<<"NF-GG    = 5"<<endl;
  outfile<<"IGOLD    = 0"<<endl;
  outfile<<"MPLANCK  = 2.4D18"<<endl;
  outfile<<"MGOLD    = 1.D-13"<<endl;
  outfile<<"******************* VARIATION OF HIGGS COUPLINGS *************************"<<endl;
  outfile<<"ELWK     = 0"<<endl;
  outfile<<"CW       = 1.D0"<<endl;
  outfile<<"CZ       = 1.D0"<<endl;
  outfile<<"Ctau     = 1.D0"<<endl;
  outfile<<"Cmu      = 1.D0"<<endl;
  outfile<<"Ct       = 1.D0"<<endl;
  outfile<<"Cb       = 1.D0"<<endl;
  outfile<<"Cc       = 1.D0"<<endl;
  outfile<<"Cs       = 1.D0"<<endl;
  outfile<<"Cgaga    = 0.D0"<<endl;
  outfile<<"Cgg      = 0.D0"<<endl;
  outfile<<"CZga     = 0.D0"<<endl;
  outfile<< "********************* 4TH GENERATION *************************************\n";
	outfile<< "Ctp      = 1.D0 " << std::endl;
	outfile<< "Cbp      = 1.D0 " << std::endl;
	outfile<< "Cnup     = 1.D0 " << std::endl;
	outfile<< "Cep      = 1.D0 " << std::endl;

  outfile.close();
}

void HdecayCalcC2HDM(std::map<std::string,double> & Hdecay){
  double h1_val[14],h2_val[16],h3_val[20],hc_val[14],top_val[3];
  hdecaycallc2hdm_(h1_val,h2_val,h3_val,hc_val,top_val);

//fill the maps with the values from hdecay
  // H1
  Hdecay["Width(H1)"]=h1_val[0];
  Hdecay["BR(H1 -> t tbar)"]=h1_val[1]; // always = 0 (as min(mH)<=125)
  Hdecay["BR(H1 -> b bbar)"]=h1_val[2];
  Hdecay["BR(H1 -> tau+ tau-)"]=h1_val[3];
  Hdecay["BR(H1 -> c cbar)"]=h1_val[4];
  Hdecay["BR(H1 -> s sbar)"]=h1_val[5];
  Hdecay["BR(H1 -> mu+ mu-)"]=h1_val[6];
  Hdecay["BR(H1 -> g g)"]=h1_val[7];
  Hdecay["BR(H1 -> gamma gamma)"]=h1_val[8];
  Hdecay["BR(H1 -> Z gamma)"]=h1_val[9];
  Hdecay["BR(H1 -> W+ W-)"]=h1_val[10];
  Hdecay["BR(H1 -> Z Z)"]=h1_val[11];
  Hdecay["BR(H1 -> W+ H-)+BR(H1 -> W- H+)"]=h1_val[12]; // always = 0
  Hdecay["BR(H1 -> H+ H-)"]=h1_val[13]; // always = 0
//
//   // H2
  Hdecay["Width(H2)"]=h2_val[0];
  Hdecay["BR(H2 -> t tbar)"]=h2_val[1];
  Hdecay["BR(H2 -> b bbar)"]=h2_val[2];
  Hdecay["BR(H2 -> tau+ tau-)"]=h2_val[3];
  Hdecay["BR(H2 -> c cbar)"]=h2_val[4];
  Hdecay["BR(H2 -> s sbar)"]=h2_val[5];
  Hdecay["BR(H2 -> mu+ mu-)"]=h2_val[6];
  Hdecay["BR(H2 -> g g)"]=h2_val[7];
  Hdecay["BR(H2 -> gamma gamma)"]=h2_val[8];
  Hdecay["BR(H2 -> Z gamma)"]=h2_val[9];
  Hdecay["BR(H2 -> W+ W-)"]=h2_val[10];
  Hdecay["BR(H2 -> Z Z)"]=h2_val[11];
  Hdecay["BR(H2 -> W+ H-)+BR(H2 -> W- H+)"]=h2_val[12];
  Hdecay["BR(H2 -> Z H1)"]=h2_val[13];
  Hdecay["BR(H2 -> H+ H-)"]=h2_val[14];
  Hdecay["BR(H2 -> H1 H1)"]=h2_val[15];
//
//   // H3
  Hdecay["Width(H3)"]=h3_val[0];
  Hdecay["BR(H3 -> t tbar)"]=h3_val[1];
  Hdecay["BR(H3 -> b bbar)"]=h3_val[2];
  Hdecay["BR(H3 -> tau+ tau-)"]=h3_val[3];
  Hdecay["BR(H3 -> c cbar)"]=h3_val[4];
  Hdecay["BR(H3 -> s sbar)"]=h3_val[5];
  Hdecay["BR(H3 -> mu+ mu-)"]=h3_val[6];
  Hdecay["BR(H3 -> g g)"]=h3_val[7];
  Hdecay["BR(H3 -> gamma gamma)"]=h3_val[8];
  Hdecay["BR(H3 -> Z gamma)"]=h3_val[9];
  Hdecay["BR(H3 -> W+ W-)"]=h3_val[10];
  Hdecay["BR(H3 -> Z Z)"]=h3_val[11];
  Hdecay["BR(H3 -> W+ H-)+BR(H3 -> W- H+)"]=h3_val[12];
  Hdecay["BR(H3 -> Z H1)"]=h3_val[13];
  Hdecay["BR(H3 -> Z H2)"]=h3_val[14];
  Hdecay["BR(H3 -> H+ H-)"]=h3_val[15];
  Hdecay["BR(H3 -> H1 H1)"]=h3_val[16];
  Hdecay["BR(H3 -> H2 H2)"]=h3_val[17];
  Hdecay["BR(H3 -> H1 H2)"]=h3_val[18];
  // clog<<"mH3 hdecay: "<<h3_val[19]<<endl;

  // H+
  Hdecay["Width(H+)"]=hc_val[0];
  Hdecay["BR(H+ -> t bbar)"]=hc_val[1];
  Hdecay["BR(H+ -> t sbar)"]=hc_val[2];
  Hdecay["BR(H+ -> t dbar)"]=hc_val[3];
  Hdecay["BR(H+ -> c bbar)"]=hc_val[4];
  Hdecay["BR(H+ -> c sbar)"]=hc_val[5];
  Hdecay["BR(H+ -> c dbar)"]=hc_val[6];
  Hdecay["BR(H+ -> u bbar)"]=hc_val[7];
  Hdecay["BR(H+ -> u sbar)"]=hc_val[8];
  Hdecay["BR(H+ -> tau+ nu_tau)"]=hc_val[9];
  Hdecay["BR(H+ -> mu+ nu_mu)"]=hc_val[10];
  Hdecay["BR(H+ -> W+ H1)"]=hc_val[11];
  Hdecay["BR(H+ -> W+ H2)"]=hc_val[12];
  Hdecay["BR(H+ -> W+ H3)"]=hc_val[13];

  //Top
  Hdecay["Width(t)"]=top_val[0];
  Hdecay["BR(t -> b W+)"]=top_val[1];
  Hdecay["BR(t -> b H+)"]=top_val[2];
  //
  // for(auto elem: Hdecay)
  //   clog<<elem.first<<"          \t"<<elem.second<<"\n";
}
